#ifndef _TOKENIZER_H_
#define _TOKENIZER_H_

// uncomment the line below to get extra printfs for debugging purposes
//#define DEBUG_MODE

// the following constant defines the maximum number of tokens we can identify
// in a given string 
#define MAX_NB_TOKENS 255

enum token_type {INTEGER, FLOATING, OPERATOR, TEXT, NOTSET}; 
typedef enum token_type TokenType; 

struct token {
	char* 		str; 
	TokenType	type;
}; 
typedef struct token Token; 

struct tokens { 
	Token** tokens; 
	int maxnbtokens; 
}; 
typedef struct tokens Tokens; 

void 		tokenize(Tokens* tokens, char * str); 
Tokens* 	tokens_allocate(int maxnbtokens); 
void 		tokens_display(Tokens* tokens); 
void 		tokens_deallocate(Tokens* tokens);

#endif
